tff('Tree', type, 'Tree': $tType).

tff(empty, type, 'empty:Tree': 'Tree').
tff(left, type, 'left:(Tree)>Tree': 'Tree' > 'Tree').
tff(val, type, 'val:(Tree)>Int': 'Tree' > $int).
tff(node, type, 'node:(Int*Tree*Tree)>Tree': ($int * 'Tree' * 'Tree') > 'Tree').
tff(right, type, 'right:(Tree)>Tree': 'Tree' > 'Tree').

%% ∀ X:Tree ((X = empty) ∨ (X = node(val(X), left(X), right(X))))
tff(formula, axiom,
  ( ! [X:'Tree'] :
      ( (X = 'empty:Tree')
      | (X = 'node:(Int*Tree*Tree)>Tree'('val:(Tree)>Int'(X), 'left:(Tree)>Tree'(X), 'right:(Tree)>Tree'(X)))))).

%% ∀ X_1_0:Int X_1_1:Tree X_1_2:Tree (val(node(X_1_0, X_1_1, X_1_2)) = X_1_0)
tff(formula, axiom,
  ( ! [X_1_0:$int, X_1_1:'Tree', X_1_2:'Tree'] :
      ('val:(Tree)>Int'('node:(Int*Tree*Tree)>Tree'(X_1_0, X_1_1, X_1_2)) = X_1_0))).

%% ∀ X_1_0:Int X_1_1:Tree X_1_2:Tree (left(node(X_1_0, X_1_1, X_1_2)) = X_1_1)
tff(formula, axiom,
  ( ! [X_1_0:$int, X_1_1:'Tree', X_1_2:'Tree'] :
      ('left:(Tree)>Tree'('node:(Int*Tree*Tree)>Tree'(X_1_0, X_1_1, X_1_2)) = X_1_1))).

%% ∀ X_1_0:Int X_1_1:Tree X_1_2:Tree (right(node(X_1_0, X_1_1, X_1_2)) = X_1_2)
tff(formula, axiom,
  ( ! [X_1_0:$int, X_1_1:'Tree', X_1_2:'Tree'] :
      ('right:(Tree)>Tree'('node:(Int*Tree*Tree)>Tree'(X_1_0, X_1_1, X_1_2)) = X_1_2))).

%% ∀ X_1_0:Int X_1_1:Tree X_1_2:Tree ¬(empty = node(X_1_0, X_1_1, X_1_2))
tff(formula, axiom,
  ( ! [X_1_0:$int, X_1_1:'Tree', X_1_2:'Tree'] :
      ('empty:Tree' != 'node:(Int*Tree*Tree)>Tree'(X_1_0, X_1_1, X_1_2)))).

