% As used originally in Beagle:
tff(hack_1, axiom, ~(? [X: $real] : (2.0 = '#nlpp'(X, X)))).

tff(quo_1, axiom, ![X: $real, Y: $real]: ( Y != 0.0 => X = $product(Y, $quotient(X, Y))) ).
% quo_1 provable from nonzero_eq_divide_eq

% Quotient definition
%% lemma nonzero_eq_divide_eq [field_simps]: "c ≠ 0 ⟹ a = b / c ⟷ a * c = b"
% nonzero_eq_divide_eq unsound without guard Y!=0
% note: nonzero_eq_divide_eq eventually causes a bug where rat is initialised with x/0?
tff(nonzero_eq_divide_eq, axiom, ![X: $real, Y: $real, Z: $real]: ( Y != 0.0 => ( Z = $quotient(X, Y) <=> X = $product(Y, Z)) ) ).

%% %% lemma divide_divide_eq_left [simp]: "(a / b) / c = a / (b * c)"
%% tff(divide_divide_eq_left, axiom, ![X: $real, Y: $real, Z: $real]: $quotient($quotient(X,Y),Z) = $quotient(X, $product(Y, Z))).

%% %% lemma divide_divide_eq_right [simp]: "a / (b / c) = (a * c) / b"
%% tff(divide_divide_eq_right, axiom, ![X: $real, Y: $real, Z: $real]: $quotient(X, $quotient(Y,Z)) = $quotient($product(X, Y), Z)).

% Definition
tff(mult_def_1, axiom, ![N: $real]: '#nlpp'(0.0, N) = 0.0).
tff(mult_def_2, axiom, ![M: $real, N: $real] : $product($sum(1.0, M), N) = $sum(N, $product(M, N)) ).

%% % Basic axioms
tff(mult_comm, axiom, ![A: $real, B: $real]: $product(A,B) = $product(B,A)).
tff(mult_dist, axiom, ![A: $real, B: $real, C: $real]: $product(A, $sum(B,C)) = $sum($product(A, B), $product(A, C))).
% Kills performance
%% tff(mult_assoc, axiom, ![A: $real, B: $real, C: $real]: $product($product(A,B),C) = $product(A, $product(B,C))).

% Lemmas for simplification
%lemma minus_mult_left: "- (a * b) = - a * b"
tff(minus_mult_left, axiom, ![A: $real, B: $real]: $uminus($product(A, B)) = $product($uminus(A), B)).
% conjecture not provable

%% lemma mult_cancel_right1 [simp]: "c = b * c ⟷ c = 0 ∨ b = 1"
tff(mult_cancel_right1, axiom, ![C: $real, B: $real]: ($product(C, B) = C <=> (C = 0.0 | B = 1.0))).
% not provable
% provable from comm, mult_eq_0 in 8s

%% %% lemma mult_pos_pos[simp]: "0 < a ⟹ 0 < b ⟹ 0 < a * b"
tff(mult_nonneg_nonneg, axiom, ![A: $real, B: $real]: (($less(0.0, A) & $less(0.0,B)) => $less(0.0, $product(A,B)))).
%% % not provable

%% lemma times_divide_eq_right [simp]: "a * (b / c) = (a * b) / c"
tff(times_divide_eq_right, axiom, ![A: $real, B: $real, C: $real]: ($product(A, $quotient(B, C)) = $quotient($product(A, B), C)) ).
%% % not provable

%% lemma divide_minus_left [simp]: "(-a) / b = - (a / b)"
tff(divide_minus_left, axiom, ![A: $real, B: $real]: $quotient($uminus(A), B) = $uminus($quotient(A, B))).
% not provable

%% lemma divide_minus_right [simp]: "a / - b = - (a / b)"
tff(divide_minus_right, axiom, ![A: $real, B: $real]: $quotient(A, $uminus(B)) = $uminus($quotient(A, B))).

%% lemma add_divide_eq_iff [field_simps]: "z ≠ 0 ⟹ x + y / z = (x * z + y) / z"
tff(add_divide_eq_iff, axiom, ![A: $real, B: $real, C: $real]: (C != 0.0 => $sum(A, $quotient(B, C)) = $quotient($sum($product(A, C), B), C)) ).
% not provable

tff(simpler_add_divide, axiom, ![A: $real, B: $real, C: $real]: ( C != 0.0 => ($sum($quotient(A, C), $quotient(B, C)) = $quotient($sum(A, B), C)) )).
% doesnt help to prove add_divide_eq_iff, neither is it provable from that

%% lemma nonzero_mult_divide_mult_cancel_left [simp]: "(c * a) / (c * b) = a / b"
tff(nonzero_mult_divide_mult_cancel_left, axiom, ![A: $real, B: $real, C: $real]: ( B != 0.0 => $quotient($product(C, A), $product(C, B)) = $quotient(A, B))).

%% lemma pos_le_divide_eq [field_simps]:
%%   assumes "0 < c"
%%   shows "a ≤ b / c ⟷ a * c ≤ b"

%% lemma pos_less_divide_eq [field_simps]:
%%   assumes "0 < c"
%%   shows "a < b / c ⟷ a * c < b"
tff(pos_less_divide_eq, axiom, ![A: $real, B: $real, C: $real]: ($less(0.0, C) => ($less(A, $quotient(B, C)) <=> $less($product(A, C), B)))).

%% lemma le_divide_eq_1_pos [simp]: "0 < a ⟹ (1 ≤ b/a) = (a ≤ b)"
tff(le_divide_eq_1_pos, axiom, ![A: $real, B: $real]: ($less(0.0, A) => ($lesseq(1.0, $quotient(B, A)) <=> $lesseq(A, B))) ).

%% lemma less_divide_eq_1_pos [simp]: "0 < a ⟹ (1 < b/a) = (a < b)"
tff(less_divide_eq_1_pos, axiom, ![A: $real, B: $real]: ($less(0.0, A) => ($less(1.0, $quotient(B, A)) <=> $less(A, B))) ).
